﻿/*
 * Layout.js ver 0.50
 * default layout system
 * (c) anabasis.jp
 */

//var vImageFN = "img/";
//jamLoadImage( [
//] );

var iBG = jamNewDiv( "SceneBG" );
var iFG1v = jamNewDiv( "SceneFG1v" );
var iFG2v = jamNewDiv( "SceneFG2v" );
var iFG1h = jamNewDiv( "SceneFG1h" );
var iFG2h = jamNewDiv( "SceneFG2h" );
var iCF1 = jamNewDiv( "Chara1FC" );
var iCF2 = jamNewDiv( "Chara2FC" );
var iCF3 = jamNewDiv( "Chara3FC" );
var iCF1o = jamNewDiv( "Chara1FCo" );
var iCF2o = jamNewDiv( "Chara2FCo" );
var iCF3o = jamNewDiv( "Chara3FCo" );
var iCF1x = jamNewDiv( "Chara1FX" );
var iCF2x = jamNewDiv( "Chara2FX" );
var iCF3x = jamNewDiv( "Chara3FX" );
var iCF1n = jamNewDiv( "Chara1NM" );
var iCF2n = jamNewDiv( "Chara2NM" );
var iCF3n = jamNewDiv( "Chara3NM" );
var tC1 = jamNewDiv( "Chara1TX" );
var tC1b = jamNewDiv( "Chara1TXb" );
var tC2 = jamNewDiv( "Chara2TX" );
var tC2b = jamNewDiv( "Chara2TXb" );
var tC3 = jamNewDiv( "Chara3TX" );
var tC3b = jamNewDiv( "Chara3TXb" );
var tS1 = jamNewDiv( "Story1TX" );
var tS2 = jamNewDiv( "Story2TX" );
var tP1 = jamNewDiv( "Caption1TX" );
var tP2 = jamNewDiv( "Caption2TX" );
var tP3 = jamNewDiv( "Caption3TX" );
var tT1 = jamNewDiv( "Task1TX" );
var tT2 = jamNewDiv( "Task2TX" );
var t8A0 = jamNewDiv( "SelEight0TX" );
var t8A1 = jamNewDiv( "SelEight1TX" );
var t8A2 = jamNewDiv( "SelEight2TX" );
var t8A3 = jamNewDiv( "SelEight3TX" );
var t8A4 = jamNewDiv( "SelEight4TX" );
var t8A5 = jamNewDiv( "SelEight5TX" );
var t8A6 = jamNewDiv( "SelEight6TX" );
var t8A7 = jamNewDiv( "SelEight7TX" );
var t8A8 = jamNewDiv( "SelEight8TX" );
var wHis = jamNewDiv( "History" );
var bH = jamNewDiv( "MenuHistory" );
var bQ = jamNewDiv( "MenuQuit" );
var bS = jamNewDiv( "MenuSave" );

var iCE1a_all = jamNewDivs( "Chara1EPa", 10, 100 );
var iCE1b_all = jamNewDivs( "Chara1EPb", 10, 100 );
var iCE2a_all = jamNewDivs( "Chara2EPa", 10, 100 );
var iCE2b_all = jamNewDivs( "Chara2EPb", 10, 100 );
var iCE3a_all = jamNewDivs( "Chara3EPa", 10, 100 );
var iCE3b_all = jamNewDivs( "Chara3EPb", 10, 100 );

var iBG_all = [iBG];
var iFG_all = [iFG1v, iFG2v, iFG1h, iFG2h];
var i_FX_new = [iCF1, iCF2, iCF3]; // エフェクト（表側）
var i_FX_old = [iCF1o, iCF2o, iCF3o]; // エフェクト（裏側）
var i_IM_all = [iBG, iFG1v, iFG2v, iFG1h, iFG2h, iCF1x, iCF2x, iCF3x, iCF1n, iCF2n, iCF3n]; // 通常の画像
var i_save = [iBG, iFG1v, iFG2v, iFG1h, iFG2h, iCF1, iCF2, iCF3];
var tC_all = [tC1, tC2, tC3];
var tCb_all = [tC1b, tC2b, tC3b]; // テキスト背景
var tS_all = [tS1, tS2];
var tP_all = [tP1, tP2, tP3];
var tT_all = [tT1, tT2]; // 例外的にテキストではない（システム用）
var t8A_all = [t8A0, t8A1, t8A2, t8A3, t8A4, t8A5, t8A6, t8A7, t8A8];
var txA_all = [t8A0, t8A1, t8A2, t8A3, t8A4, t8A5, t8A6, t8A7, t8A8];
var t_all = [tC1, tC2, tC3, tS1, tS2, tP1, tP2, tP3, t8A0, t8A1, t8A2, t8A3, t8A4, t8A5, t8A6, t8A7, t8A8];
var t_save = [tC1, tC2, tC3, tS1, tS2, tP1, tP2, tP3];
var b_all = [bH, bQ, bS];

var vTimer = null;
var vTime100 = ["time", 100, ""];
var vTime150 = ["time", 150, ""];
var vTime250 = ["time", 250, ""];
var vTime500 = ["time", 500, ""];

var vTimeEf = ["time", 2000, ""];
var vTimeEcS = ["time", 120, ""];
var vTimeEcM = ["time", 240, ""];
var vTimeEcL = ["time", 360, ""];
var vTimeEw = ["time", 1500, ""];

var vTimeS = ["time", 500, ""];
var vTimeM = ["time", 1000, ""];
var vTimeL = ["time", 2000, ""];

var vTimeT = ["time", 500, "linear"];

var vSelect = 0; // -1=選択肢表示中（スキップ不可）、0以上=選択値（スキップ可）
var vAutoSkip = 0; // 自動スキップ 0=オフ、1以上=オン
var vSkipCount = 0; // 自動スキップ カウンター
var vSkipLoop = 1; // 自動スキップするブリンクのループ数
var vReturn = 0; // 0=通常終了、1=メニューへ
var vReturnWait = 250; // 終了時の待機時間
var vWait = 0; // ラベル用カウンタ
var vLastWait = 0; // ラベル用カウンタ
var vDispSave = 0; // セーブボタン表示 0=する、1=しない

var vCF1src = "";
var vCF2src = "";
var vCF3src = "";
var vTextLife = 4;
var vHistory = 0; // 履歴の状態、0=開いてない、0以上=開いている

var vNowPlay = "BGM0"; // 再生中のオーディオ

function init_i() {
	//return [jacDivClear( i_FX_new ), jacDivClear( i_FX_old ), jacDivClear( i_IM_all ), jacDivClear( iCE1a_all ), jacDivClear( iCE1b_all ), jacDivClear( iCE2a_all ), jacDivClear( iCE2b_all ), jacDivClear( iCE3a_all ), jacDivClear( iCE3b_all )];
	return [jacDivTransform( i_FX_new, [1], [0], [0] ), jacDivTransform( i_FX_old, [1], [0], [0] ), jacDivTransform( i_IM_all, [1], [0], [0] ), jacDivTransform( iCE1a_all, [1], [0], [0] ), jacDivTransform( iCE1b_all, [1], [0], [0] ), jacDivTransform( iCE2a_all, [1], [0], [0] ), jacDivTransform( iCE2b_all, [1], [0], [0] ), jacDivTransform( iCE3a_all, [1], [0], [0] ), jacDivTransform( iCE3b_all, [1], [0], [0] )];
}
function set_iBG( name ) {
	return jacDivImage( iBG, vImageFN+name );
}
function set_iFG1v( name ) {
	return [jacOpacityEy( tC1b, "DispLife", vTextLife, tC1b, [1, 0] ), jacDivImage( iFG1v, vImageFN+name ), jacTransform( iFG1v, [1], [0], [0, 0, 0, 240] ), jacOpacityEx( iBG, [1, 0.25] )];
}
function set_iFG2v( name ) {
	return [jacOpacityEy( tC3b, "DispLife", vTextLife, tC3b, [1, 0] ), jacDivImage( iFG2v, vImageFN+name ), jacTransform( iFG2v, [1], [0], [0, 0, 0, -240] ), jacOpacityEx( iBG, [1, 0.25] )];
}
function set_iFG1h( name ) {
	return [jacOpacityEy( tC1b, "DispLife", vTextLife, tC1b, [1, 0] ), jacDivImage( iFG1h, vImageFN+name ), jacTransform( iFG1h, [1], [0], [0, 0, 0, 160] ), jacOpacityEx( iBG, [1, 0.25] )];
}
function set_iFG2h( name ) {
	return [jacOpacityEy( tC3b, "DispLife", vTextLife, tC3b, [1, 0] ), jacDivImage( iFG2h, vImageFN+name ), jacTransform( iFG2h, [1], [0], [0, 0, 0, -160] ), jacOpacityEx( iBG, [1, 0.25] )];
}
function set_iCF1( name ) {
	return [jacTransform( iCF1o, [1, 0.75], [0], [0] ), jacDivImageCopy( iCF1, iCF1o, 1 ), jacClear( iCF1 ), jacDivImage( iCF1, vImageFN+name, [0, 1] ), jacOpacityEx( iCF1x, [1, 0] ), function ( t ) { if ( t == 1 ) vCF1src = vImageFN+name; }];
}
function set_iCF2( name ) {
	return [jacTransform( iCF2o, [1, 0.75], [0], [0] ), jacDivImageCopy( iCF2, iCF2o, 1 ), jacClear( iCF2 ), jacDivImage( iCF2, vImageFN+name, [0, 1] ), jacOpacityEx( iCF2x, [1, 0] ), function ( t ) { if ( t == 1 ) vCF2src = vImageFN+name; }];
}
function set_iCF3( name ) {
	return [jacTransform( iCF3o, [1, 0.75], [0], [0] ), jacDivImageCopy( iCF3, iCF3o, 1 ), jacClear( iCF3 ), jacDivImage( iCF3, vImageFN+name, [0, 1] ), jacOpacityEx( iCF3x, [1, 0] ), function ( t ) { if ( t == 1 ) vCF3src = vImageFN+name; }];
}

function set_iCF1x( name ) {
	return jacDivImage( iCF1x, vImageFN+name, [0, 1] );
}
function set_iCF2x( name ) {
	return jacDivImage( iCF2x, vImageFN+name, [0, 1] );
}
function set_iCF3x( name ) {
	return jacDivImage( iCF3x, vImageFN+name, [0, 1] );
}

function set_iCF1n( name ) {
	return jacDivImage( iCF1n, vImageFN+name, [0, 1] );
}
function set_iCF2n( name ) {
	return jacDivImage( iCF2n, vImageFN+name, [0, 1] );
}
function set_iCF3n( name ) {
	return jacDivImage( iCF3n, vImageFN+name, [0, 1] );
}

function set_iCE1a( name, fin ) {
	if ( fin == null ) fin = false;
	return [jacDivTransformEx( [iCF1, iCF1o], [1], [0], [0, 50, 0, 0] ), jacImageArray( iCE1a_all, vImageFN+name ), jacOpacityArray( iCE1a_all, [0, 1] )];
}
function set_iCE1b( name, fin ) {
	if ( fin == null ) fin = false;
	return [jacDivTransformEx( [iCF1, iCF1o], [1], [0], [0, 50, 0, 0] ), jacImageArray( iCE1b_all, vImageFN+name ), jacOpacityArray( iCE1b_all, [0, 1] )];
}
function set_iCE2a( name, fin ) {
	if ( fin == null ) fin = false;
	return [jacDivTransformEx( [iCF2, iCF2o], [1], [0], [0, -50, 0, 0] ), jacImageArray( iCE2a_all, vImageFN+name ), jacOpacityArray( iCE2a_all, [0, 1] )];
}
function set_iCE2b( name, fin ) {
	if ( fin == null ) fin = false;
	return [jacDivTransformEx( [iCF2, iCF2o], [1], [0], [0, -50, 0, 0] ), jacImageArray( iCE2b_all, vImageFN+name ), jacOpacityArray( iCE2b_all, [0, 1] )];
}
function set_iCE3a( name, fin ) {
	if ( fin == null ) fin = false;
	return [jacDivTransformEx( [iCF3, iCF3o], [1], [0], [0, 50, 0, 0] ), jacImageArray( iCE3a_all, vImageFN+name ), jacOpacityArray( iCE3a_all, [0, 1] )];
}
function set_iCE3b( name, fin ) {
	if ( fin == null ) fin = false;
	return [jacDivTransformEx( [iCF3, iCF3o], [1], [0], [0, 50, 0, 0] ), jacImageArray( iCE3b_all, vImageFN+name ), jacOpacityArray( iCE3b_all, [0, 1] )];
}

function emoCF1( type ) {
	return emoCF( type, [iCF1, iCF1o], iCF1x );
}
function emoCF2( type ) {
	return emoCF( type, [iCF2, iCF2o], iCF2x );
}
function emoCF3( type ) {
	return emoCF( type, [iCF3, iCF3o], iCF3x );
}

function emoCX1( type ) {
	return emoCX( type, tC1 );
}
function emoCX2( type ) {
	return emoCX( type, tC2 );
}
function emoCX3( type ) {
	return emoCX( type, tC3 );
}

function init_t() {
	//return jacDivClear( t_all );
	return [jacDivTransform( t_all, [1], [0], [0] )]
}
// elem.innerHTML = "<table style='width:100%;'><tr><td "+ali+" "+vali+">"+disp_str+"<span style='opacity:0.0;'>"+remain_str+"</span></td></tr></table>";

function set_tC1( text, ali, vali ) {
	text = genStoryText( text );
	return [jacOpacityEx( tC1b, [0, 1] ), jacDivTextOp( tC1, text ), "do", function () {
		if ( jamSP ) { var fw = 32; var fh = 64; } else { var fw = 44; var fh = 88; }
		var img = ""; if ( 0 < vCF1src.length) img = "<img style='width:"+fw+"px;height:"+fh+"px;' src='"+vCF1src+"'>";
		wHis.innerHTML += "<table border='0' cellpadding='0' cellspacing='0'><tr><td style='width:"+fw+"px;height:"+fh+"px;'>"+img+"</td><td>"+text+"</td></tr></table>";
		//wHis.scrollTop = wHis.scrollHeight;
		tC1b.setAttribute( "DispLife", vTextLife );
	}];
}
function set_tC2( text, ali, vali ) {
	text = genStoryText( text );
	return [jacOpacityEx( tC2b, [0, 1] ), jacDivTextOp( tC2, text ), "do", function () {
		if ( jamSP ) { var fw = 32; var fh = 64; } else { var fw = 44; var fh = 88; }
		var img = ""; if ( 0 < vCF2src.length) img = "<img style='width:"+fw+"px;height:"+fh+"px;' src='"+vCF2src+"'>";
		wHis.innerHTML += "<table border='0' cellpadding='0' cellspacing='0'><tr><td style='width:"+fw+"px;height:"+fh+"px;'>"+img+"</td><td>"+text+"</td></tr></table>";
		//wHis.scrollTop = wHis.scrollHeight;
		tC2b.setAttribute( "DispLife", vTextLife );
	}];
}
function set_tC3( text, ali, vali ) {
	text = genStoryText( text );
	return [jacOpacityEx( tC3b, [0, 1] ), jacDivTextOp( tC3, text ), "do", function () {
		if ( jamSP ) { var fw = 32; var fh = 64; } else { var fw = 44; var fh = 88; }
		var img = ""; if ( 0 < vCF3src.length) img = "<img style='width:" + fw + "px;height:" + fh + "px;' src='"+vCF3src+"'>";
		wHis.innerHTML += "<table border='0' cellpadding='0' cellspacing='0'><tr><td style='width:"+fw+"px;height:"+fh+"px;'>"+img+"</td><td>"+text+"</td></tr></table>";
		//wHis.scrollTop = wHis.scrollHeight;
		tC3b.setAttribute( "DispLife", vTextLife );
	}];
}
function set_tS1( text, ali, vali ) {
	text = genStoryText( text );
	return [jacDivTextOp( tS1, text ), "do", function () {
		if ( jamSP ) { var fw = 32; var fh = 32; } else { var fw = 33; var fh = 66; }
		wHis.innerHTML += "<table border='0' cellpadding='0' cellspacing='0'><tr><td style='width:"+fw+"px;height:"+fh+"px;'></td><td>"+text+"</td><td style='width:"+fw+"px;height:"+fh+"px;'></td></tr></table>";
		//wHis.scrollTop = wHis.scrollHeight;
	}];
}
function set_tS2( text, ali, vali ) {
	text = genStoryText( text );
	return [jacDivTextOp( tS2, text ), "do", function () {
		if ( jamSP ) { var fw = 32; var fh = 32; } else { var fw = 33; var fh = 66; }
		wHis.innerHTML += "<table border='0' cellpadding='0' cellspacing='0'><tr><td style='width:"+fw+"px;height:"+fh+"px;'></td><td>"+text+"</td><td style='width:"+fw+"px;height:"+fh+"px;'></td></tr></table>";
		//wHis.scrollTop = wHis.scrollHeight;
	}];
}
function set_tP1( text, ali, vali ) {
	text = genStoryText( text );
	if ( text == null ) return [jacTextEx( tP1, "DispText" ), jacOpacityEx( tP1, [0, 1] )];
	return [jacDivTextOp( tP1, text )];
}
function set_tP2( text, ali, vali ) {
	text = genStoryText( text );
	if ( text == null ) return [jacTextEx( tP2, "DispText" ), jacOpacityEx( tP2, [0, 1] )];
	return [jacDivTextOp( tP2, text )];
}
function set_tP3( text, ali, vali ) {
	text = genStoryText( text );
	if ( text == null ) return [jacTextEx( tP3, "DispText" ), jacOpacityEx( tP3, [0, 1] )];
	return [jacDivTextOp( tP3, text )];
}

function set_t8A( index, text ) {
	if ( text.length <= 0 ) {
		return jacNone();
	}
	text = genStoryText( text );
	if ( index == 0 ) text = "<table><tr><td class='SelEightTopCenter'>" + text + "</td></tr></table>";
	else text = "<table><tr><td class='SelEightCenter'>" + text + "</td></tr></table>";
	
	switch( index ) {
		case 0: return [jacTransformScale( t8A0, [1] ), jacDivTextOp( t8A0, text )];
		case 1: return [jacTransformScale( t8A1, [1] ), jacDivTextOp( t8A1, text )];
		case 2: return [jacTransformScale( t8A2, [1] ), jacDivTextOp( t8A2, text )];
		case 3: return [jacTransformScale( t8A3, [1] ), jacDivTextOp( t8A3, text )];
		case 4: return [jacTransformScale( t8A4, [1] ), jacDivTextOp( t8A4, text )];
		case 5: return [jacTransformScale( t8A5, [1] ), jacDivTextOp( t8A5, text )];
		case 6: return [jacTransformScale( t8A6, [1] ), jacDivTextOp( t8A6, text )];
		case 7: return [jacTransformScale( t8A7, [1] ), jacDivTextOp( t8A7, text )];
		case 8: return [jacTransformScale( t8A8, [1] ), jacDivTextOp( t8A8, text )];
	}
}

function set_wHis() {
	return jacDivOpacityEx( wHis, [0, getHistoryHO()] );
}

function del_iBG() {
	return jacDivOpacityEx( iBG_all, [1, 0] );
}
function del_iFG( keep ) {
	if ( keep == null ) keep = false;
	if ( keep ) {
		return [
			jacOpacityEx( iFG1v, [1, 0] ), jacTransform( iFG1v, [1], [0], [0, 0, 240, 0] ),
			jacOpacityEx( iFG2v, [1, 0] ), jacTransform( iFG2v, [1], [0], [0, 0, -240, 0] ),
			jacOpacityEx( iFG1h, [1, 0] ), jacTransform( iFG1h, [1], [0], [0, 0, 160, 0] ),
			jacOpacityEx( iFG2h, [1, 0] ), jacTransform( iFG2h, [1], [0], [0, 0, -160, 0] ),
		];
	}
	else {
		return [
			jacOpacityEx( iFG1v, [1, 0] ), jacTransform( iFG1v, [1], [0], [0, 0, 240, 0] ),
			jacOpacityEx( iFG2v, [1, 0] ), jacTransform( iFG2v, [1], [0], [0, 0, -240, 0] ),
			jacOpacityEx( iFG1h, [1, 0] ), jacTransform( iFG1h, [1], [0], [0, 0, 160, 0] ),
			jacOpacityEx( iFG2h, [1, 0] ), jacTransform( iFG2h, [1], [0], [0, 0, -160, 0] ),
			jacOpacityEx( iBG, [0.25, 1] )
		];
	}
	//return [jacDivOpacityEx( iFG_all, [1, 0] ), jacDivOpacityEx( iBG, [0.25, 1] )];
}
function del_iCF1() {
	return [jacOpacityEx( tC1b, [1, 0] ), jacOpacityEx( iCF1, [1, 0] ), jacDivImageDelete( iCF1o, 0 ), jacOpacityEx( iCF1x, [1, 0] ), jacOpacityEx( iCF1n, [1, 0] ), function ( t ) { if ( t == 1 ) vCF1src = ""; }];
}
function del_iCF2() {
	return [jacOpacityEx( tC2b, [1, 0] ), jacOpacityEx( iCF2, [1, 0] ), jacDivImageDelete( iCF2o, 0 ), jacOpacityEx( iCF2x, [1, 0] ), jacOpacityEx( iCF2n, [1, 0] ), function ( t ) { if ( t == 1 ) vCF2src = ""; }];
}
function del_iCF3() {
	return [jacOpacityEx( tC3b, [1, 0] ), jacOpacityEx( iCF3, [1, 0] ), jacDivImageDelete( iCF3o, 0 ), jacOpacityEx( iCF3x, [1, 0] ), jacOpacityEx( iCF3n, [1, 0] ), function ( t ) { if ( t == 1 ) vCF3src = ""; }];
}
function del_i() {
	return [jacDivOpacityEx( tCb_all, [1, 0] ), jacDivOpacityEx( i_FX_new, [1, 0] ), jacDivImageDelete( i_FX_old, 0 ), jacDivOpacityEx( i_IM_all, [1, 0] ), jacDivOpacityEx( iCE1a_all, [1, 0] ), jacDivOpacityEx( iCE1b_all, [1, 0] ), jacDivOpacityEx( iCE2a_all, [1, 0] ), jacDivOpacityEx( iCE2b_all, [1, 0] ), jacDivOpacityEx( iCE3a_all, [1, 0] ), jacDivOpacityEx( iCE3b_all, [1, 0] ), function ( t ) { if ( t == 1 ) { vCF1src = ""; vCF2src = ""; vCF3src = ""; } }];
}

function del_iCE1a() {
	return [jacDivTransformEx( [iCF1, iCF1o], [1], [0], [50, 0, 0, 0] ), jacClearArray( iCE1a_all, 0 ), jacDivOpacityEx( iCE1a_all, [1, 0] )];
}
function del_iCE1b() {
	return [jacDivTransformEx( [iCF1, iCF1o], [1], [0], [50, 0, 0, 0] ), jacClearArray( iCE1b_all, 0 ), jacDivOpacityEx( iCE1b_all, [1, 0] )];
}
function del_iCE2a() {
	return [jacDivTransformEx( [iCF2, iCF2o], [1], [0], [-50, 0, 0, 0] ), jacClearArray( iCE2a_all, 0 ), jacDivOpacityEx( iCE2a_all, [1, 0] )];
}
function del_iCE2b() {
	return [jacDivTransformEx( [iCF2, iCF2o], [1], [0], [-50, 0, 0, 0] ), jacClearArray( iCE2b_all, 0 ), jacDivOpacityEx( iCE2b_all, [1, 0] )];
}
function del_iCE3a() {
	return [jacDivTransformEx( [iCF3, iCF3o], [1], [0], [50, 0, 0, 0] ), jacClearArray( iCE3a_all, 0 ), jacDivOpacityEx( iCE3a_all, [1, 0] )];
}
function del_iCE3b() {
	return [jacDivTransformEx( [iCF3, iCF3o], [1], [0], [50, 0, 0, 0] ), jacClearArray( iCE3b_all, 0 ), jacDivOpacityEx( iCE3b_all, [1, 0] )];
}

function del_tC1() {
	return [jacOpacityEy( tC1b, "DispLife", 0, tC1b, [1, 0] ), jacOpacityEx( tC1, [1, 0] )];
}
function del_tC2() {
	return [jacOpacityEy( tC2b, "DispLife", 0, tC2b, [1, 0] ), jacOpacityEx( tC2, [1, 0] )];
}
function del_tC3() {
	return [jacOpacityEy( tC3b, "DispLife", 0, tC3b, [1, 0] ), jacOpacityEx( tC3, [1, 0] )];
}
function del_tC() {
	return [del_tC1(), del_tC2(), del_tC3()];
}
function del_tS1() {
	return [jacOpacityEx( tS1, [1, 0] )];
}
function del_tS2() {
	return [jacOpacityEx( tS2, [1, 0] )];
}
function del_tS() {
	return [del_tS1(), del_tS2()];
}
function del_tP1() {
	return [jacOpacityEx( tP1, [1, 0] ), jacTransform( tP1, [1], [0], [0] )];
}
function del_tP2() {
	return [jacOpacityEx( tP2, [1, 0] ), jacTransform( tP2, [1], [0], [0] )];
}
function del_tP3() {
	return [jacOpacityEx( tP3, [1, 0] ), jacTransform( tP3, [1], [0], [0] )];
}
function del_tP() {
	return [del_tP1(), del_tP2(), del_tP3()];
}
function del_txA() {
	return jacDivOpacityEx( txA_all, [1, 0] );
}
function del_t() {
	return [del_tC1(), del_tC2(), del_tC3(), del_tS1(), del_tS2(), del_tP1(), del_tP2(), del_tP3(), del_txA(), "do", function () {
		var life1 = tC1b.getAttribute( "DispLife" ); if ( life1 != null ) tC1b.setAttribute( "DispLife", life1 - 1 );
		var life2 = tC2b.getAttribute( "DispLife" ); if ( life2 != null ) tC2b.setAttribute( "DispLife", life2 - 1 );
		var life3 = tC3b.getAttribute( "DispLife" ); if ( life3 != null ) tC3b.setAttribute( "DispLife", life3 - 1 );
	}];
}
function del_wHis() {
	return [jacDivOpacityEx( wHis, [getHistoryHO(), 0] ), function ( t ) { if ( t == 1 ) wHis.innerHTML = ""; }];
}

function setDispText( div, text ) {
	div.setAttribute( "DispText", text );
}

function clearHistory() {
	return [
		"do", function () { wHis.innerHTML = ""; },
	];
}

function audioPlay( name ) {
	return [
		"do", function () { jamPlayAudio( name ); vNowPlay = name; },
	];
}
function audioSound( name ) {
	return [
		"do", function () { jamPlayAudio( name ); },
	];
}
function audioPause() {
	return [
		"do", function () { jamPauseAudio(); vNowPlay = ""; },
	];
}
function audioQuit() {
	return [
		"do", function () { jamPlayAudio( "BGM0" ); vNowPlay = ""; },
	];
}

function label( name ) {
	return [
		"label", name,
	];
}

function skip() {
	return [
		"if",
			function () { return (0 <= vSelect); },
			function () {
				vSelect = -1;
				jamSetOnClick( document, function () { eventSkip( 999 ); } );
			},
	];
}

function wait( se ) {
	vWait++;
	var wait = vWait;
	if ( se == null ) se = false;
	return [
		"label", // シーンロード時に、戻ってくる場所
			"wait" + vWait,
		"do", // フラグの初期化
			function () { vSelect = 0; vSkipCount = 0; },
		"label", // wait完了しない場合に、戻ってくる場所
			"waitloop" + vWait,
		"stop",
		"if", // ハンドラ等の初期化
			function () { return (0 <= vSelect); },
			function () {
				if ( vAutoSkip == 0 ) {
					vSelect = -1;
					jamSetOnClick( document, function () { eventSkip( 0 ); } );
					jamSetOnClick( bH, function () { eventSkip( 1 ); } );
					jamSetOnClick( bQ, function () { eventSkip( 2 ); } );
					if ( vDispSave == 0 ) jamSetOnClick( bS, function () { eventSkip( 3 ); } );
					//jamSetOnClick( wHis, function () { eventSkip( -1 ); } );
				}
				else {
					vSelect = -1;
					jamSetOnClick( document, function () { eventSkip( 999 ); } );
				}
				
				if ( jamLR ) {
					tT1.setAttribute( "DispText", "tap next" );
					tT1.setAttribute( "DispStat", 0 );
					bH.setAttribute( "DispStat", 0 );
					bQ.setAttribute( "DispStat", 0 );
					bS.setAttribute( "DispStat", vDispSave );
					bH.setAttribute( "DispText", "　履歴切替" );
				}
				else {
					if ( jamSP ) tT1.setAttribute( "DispText", "tap next" );
					else tT1.setAttribute( "DispText", "click next" );
					if ( vAutoSkip == 0 ) {
						tT1.setAttribute( "DispStat", 0 );
						bH.setAttribute( "DispStat", 0 );
						bQ.setAttribute( "DispStat", 0 );
						bS.setAttribute( "DispStat", vDispSave );
					}
					else {
						tT1.setAttribute( "DispStat", 1 );
						bH.setAttribute( "DispStat", 1 );
						bQ.setAttribute( "DispStat", 1 );
						bS.setAttribute( "DispStat", 1 );
					}
					bH.setAttribute( "DispText", "　 自動送り" );
				}
			},
		"time", 150, "", // 表示の設定
			jacTextEx( tT1, "DispText" ),
			jacOpacityEy( tT1, "DispStat", 0, tT1, [0, 1] ),
			jacTransform( tT1, [1], [0], [0] ),
			jacTextEx( bH, "DispText" ),
			jacOpacityEy( bH, "DispStat", 0, bH, [0, 1] ),
			jacTransformScale( bH, [1] ),
			jacText( bQ, "　メニューへ" ),
			jacOpacityEy( bQ, "DispStat", 0, bQ, [0, 1] ),
			jacTransformScale( bQ, [1] ),
			jacText( bS, "　ここで保存" ),	
			jacOpacityEy( bS, "DispStat", 0, bS, [0, 1] ),
			jacTransformScale( bS, [1] ),
			function ( t ) {
				var f = jacScroll( wHis, 1.0 ); return f( t );
			},
		"do",
			function () {
				if ( 0 <= vSelect ) { // 念のため、ループ内に停止判定
					jamStopAnime();
				}
				if ( 0 < vAutoSkip ) { // 自動スキップ処理
					if ( vSkipLoop <= vSkipCount++ ) { 
						eventSkip( 0 );
					}
				} 
			},
		"time", 1000, "", // ブリンク処理１
			jacOpacityEy( tT1, "DispStat", 0, tT1, [1, 0.25] ),
		"time", 1000, "", // ブリンク処理２
			jacOpacityEy( tT1, "DispStat", 0, tT1, [0.25, 1] ),
		"back", 3, -1, // 上の３コマンドが無限ループする
		"stop", // クリック時は上でループせず、ここからアニメ再開
		"if", // 音を鳴らす
			function () { return se; },
			function () { jamPlayAudio( "SE_SEL" ); },
		"time", 150, "", // ボタン等の反応１
			jacText( tT1, "to next" ),
			jacOpacityEy( tT1, "DispStat", 0, tT1, [0, 1] ),
			jacTransform( tT1, [1, 1.5], [0], [0] ),
			function ( t ) {
				var f;
				switch ( vSelect ) {
					case 1: f = jacOpacityEy( bH, "DispStat", 0, bH, [1, 0] ); return f( t );
					case 2: f = jacOpacityEy( bQ, "DispStat", 0, bQ, [1, 0] ); return f( t );
					case 3: f = jacOpacityEy( bS, "DispStat", 0, bS, [1, 0] ); return f( t );
				}
			},
		"time", 150, "", // ボタン等の反応２
			jacOpacityEy( tT1, "DispStat", 0, tT1, [1, 0] ),
			jacTransform( tT1, [1.5, 1], [0], [0] ),
			jacOpacityEy( bH, "DispStat", 0, bH, [1, 0] ),
			jacOpacityEy( bQ, "DispStat", 0, bQ, [1, 0] ),
			jacOpacityEy( bS, "DispStat", 0, bS, [1, 0] ),
			function ( t ) {
				var f;
				switch ( vSelect ) {
					case 1:
						if ( jamLR ) { // 履歴画面の表示切替
							if ( vHistory == 0 ) f = jacOpacity( wHis, [getHistoryHO(), getHistorySO()] );
							else f = jacOpacity( wHis, [getHistorySO(), getHistoryHO()] );
							return f( t );
						}
				}
			},
		"do", // ボタンを押した場合の処理
			function () {
				switch ( vSelect ) {
					case 1: // 履歴を押した
						if ( jamLR ) {
							toggleHistory();
						}
						else {
							if( 0 < vAutoSkip ) vAutoSkip = 0;
							else vAutoSkip = 1;
						}
						break;
					case 2: // 終わるを押した
						if ( window.confirm("タイトルメニューへ戻りますか？") ) {
							vSelect = 99; vReturn = 1;
						}
						break;
					case 3: // セーブを押した
						if ( window.confirm("このシーンでセーブしますか？") ) {
							vSelect = 3; save( "wait" + wait );
						}
						break;
				}
			},
		"if goto", // スクリプト終了
			function () { return (vSelect == 99); },
			"end",
		"if goto", // wait完了でないなら、戻る
			function () { return (1 <= vSelect); },
			"waitloop" + vWait,
		"do", // フラグクリア、履歴を消す
			function () {
				vSelect = 0;
				if ( jamLR ) {
					hideHistory();
				}
			},
	];
}

function askEight( se ) {
	if ( se == null ) se = false;
	return [
		"if",
			function () { return (0 <= vSelect); },
			function () {
				vSelect = -1;
				if ( 0.0 < t8A1.style.opacity ) jamSetOnClick( t8A1, function () { eventSel( 1 ); } );
				if ( 0.0 < t8A2.style.opacity ) jamSetOnClick( t8A2, function () { eventSel( 2 ); } );
				if ( 0.0 < t8A3.style.opacity ) jamSetOnClick( t8A3, function () { eventSel( 3 ); } );
				if ( 0.0 < t8A4.style.opacity ) jamSetOnClick( t8A4, function () { eventSel( 4 ); } );
				if ( 0.0 < t8A5.style.opacity ) jamSetOnClick( t8A5, function () { eventSel( 5 ); } );
				if ( 0.0 < t8A6.style.opacity ) jamSetOnClick( t8A6, function () { eventSel( 6 ); } );
				if ( 0.0 < t8A7.style.opacity ) jamSetOnClick( t8A7, function () { eventSel( 7 ); } );
				if ( 0.0 < t8A8.style.opacity ) jamSetOnClick( t8A8, function () { eventSel( 8 ); } );
			},
		"do",
			function () {
				if ( 0 <= vSelect ) { // 念のため、ループ内に停止判定
					jamStopAnime();
				}
			},
		"time", 500, "",
			jacText( tT2, "[select]" ),
			jacOpacity( tT2, [0, 1] ),
			jacTransform( tT2, [1, 1], [0], [0] ),
		"time", 500, "",
			jacOpacity( tT2, [1, 0] ),
		"back", 3, -1, // 上の３コマンドがループする
		"stop",
		"if",
			function () { return se; },
			function () { jamPlayAudio( "SE_SEL" ); },
		"time", 500, "",
			jacText( tT2, "to next" ),
			jacOpacity( tT2, [0, 1] ),
			jacTransform( tT2, [1, 1.25], [0], [0, 0, 0, -25] ),
			function ( t ) {
				var f;
				switch ( vSelect ) {
					case 1: f = jacTransform( t8A1, [1, 1.25], [0], [0, 0, 0, -25] ); return f( t );
					case 2: f = jacTransform( t8A2, [1, 1.25], [0], [0, 0, 0, -25] ); return f( t );
					case 3: f = jacTransform( t8A3, [1, 1.25], [0], [0, 0, 0, -25] ); return f( t );
					case 4: f = jacTransform( t8A4, [1, 1.25], [0], [0, 0, 0, -25] ); return f( t );
					case 5: f = jacTransform( t8A5, [1, 1.25], [0], [0, 0, 0, -25] ); return f( t );
					case 6: f = jacTransform( t8A6, [1, 1.25], [0], [0, 0, 0, -25] ); return f( t );
					case 7: f = jacTransform( t8A7, [1, 1.25], [0], [0, 0, 0, -25] ); return f( t );
					case 8: f = jacTransform( t8A8, [1, 1.25], [0], [0, 0, 0, -25] ); return f( t );
				}
			},
		"time", 500, "",
			jacOpacity( tT2, [1, 0] ),
			jacTransform( tT2, [1.25, 1], [0], [0, 0, -25, 0] ),
			function ( t ) { if ( 0.0 < t8A1.style.opacity ) { var f = jacOpacity( t8A1, [1, 0] ); return f( t ); } },
			function ( t ) { if ( 0.0 < t8A2.style.opacity ) { var f = jacOpacity( t8A2, [1, 0] ); return f( t ); } },
			function ( t ) { if ( 0.0 < t8A3.style.opacity ) { var f = jacOpacity( t8A3, [1, 0] ); return f( t ); } },
			function ( t ) { if ( 0.0 < t8A4.style.opacity ) { var f = jacOpacity( t8A4, [1, 0] ); return f( t ); } },
			function ( t ) { if ( 0.0 < t8A5.style.opacity ) { var f = jacOpacity( t8A5, [1, 0] ); return f( t ); } },
			function ( t ) { if ( 0.0 < t8A6.style.opacity ) { var f = jacOpacity( t8A6, [1, 0] ); return f( t ); } },
			function ( t ) { if ( 0.0 < t8A7.style.opacity ) { var f = jacOpacity( t8A7, [1, 0] ); return f( t ); } },
			function ( t ) { if ( 0.0 < t8A8.style.opacity ) { var f = jacOpacity( t8A8, [1, 0] ); return f( t ); } },
			function ( t ) {
				var f;
				switch ( vSelect ) {
					case 1: f = jacTransform( t8A1, [1.25, 1], [0], [0, 0, -25, 0] ); return f( t );
					case 2: f = jacTransform( t8A2, [1.25, 1], [0], [0, 0, -25, 0] ); return f( t );
					case 3: f = jacTransform( t8A3, [1.25, 1], [0], [0, 0, -25, 0] ); return f( t );
					case 4: f = jacTransform( t8A4, [1.25, 1], [0], [0, 0, -25, 0] ); return f( t );
					case 5: f = jacTransform( t8A5, [1.25, 1], [0], [0, 0, -25, 0] ); return f( t );
					case 6: f = jacTransform( t8A6, [1.25, 1], [0], [0, 0, -25, 0] ); return f( t );
					case 7: f = jacTransform( t8A7, [1.25, 1], [0], [0, 0, -25, 0] ); return f( t );
					case 8: f = jacTransform( t8A8, [1.25, 1], [0], [0, 0, -25, 0] ); return f( t );
				}
			},
	];
}

function eventSkip( id ) {
//console.log( "eventSkip = " + id );
	if ( id < 0 ) return; // 無効な領域への操作
	if ( !jamJudgeOnClick() ) return;
	
	jamStopAnime();
	
	vSelect = id;
	jamSetOnClick( document, null );
	jamSetOnClick( bH, null );
	jamSetOnClick( bQ, null );
	jamSetOnClick( bS, null );
	//jamSetOnClick( wHis, null );
	
	if ( id == 999 ) { // アニメーションのスキップ時
		if ( 0 < vAutoSkip ) vAutoSkip = 0;
	}
	
	return;
}

function eventSel( id ) {
//console.log( "eventSel = " + id );
	if ( id < 0 ) return; // 無効な領域への操作
	if ( !jamJudgeOnClick() ) return;
	
	jamStopAnime();
	
	vSelect = id;
	for ( var i = 0; i < txA_all.length; i++ ) {
		jamSetOnClick( txA_all[i], null );
	};
	return;
}

function showHistory() {
//console.log( "showHistory() called." );
	vHistory = 1;
	wHis.style.opacity = getHistorySO();
}
function hideHistory() {
//console.log( "hideHistory() called." );
	vHistory = 0;
	wHis.style.opacity = getHistoryHO();
}
function toggleHistory() {
//console.log( "toggleHistory() called." );
	if ( vHistory == 0.0 ) { showHistory(); }
	else { hideHistory(); }
}
function getHistorySO() {
	return 1.0;
}
function getHistoryHO() {
	if ( jamLR ) return 0.0;
	else return 1.0;
}

function saveItem( key, value ) {
	if ( !localStorage ) {
		var nowtime = new Date().getTime();
		var cleartime = new Date(nowtime + (10 * 365 * 24 * 60 * 60 * 1000));
		var expires = cleartime.toGMTString();
		var cookie = key + "=" + encodeURIComponent( value ) + "; expires=" + expires + "";
console.log( "cookie = " + cookie );
		document.cookie = cookie;
	}
	else {
		localStorage.setItem( key, value );
	}
}
function loadItem( key ) {
	if ( !localStorage ) {
		var result = null;
		var cookieName = key + '=';
		var allcookies = document.cookie;
console.log( "allcookies = " + allcookies );
		var position = allcookies.indexOf( cookieName );
		if( position != -1 ) {
			var startIndex = position + cookieName.length;
			var endIndex = allcookies.indexOf( ';', startIndex );
			if( endIndex == -1 ) {
				endIndex = allcookies.length;
			}
			result = decodeURIComponent( allcookies.substring( startIndex, endIndex ) );
		}
		return result;
	}
	else {
		return localStorage.getItem( key );
	}
}
function setDispSave( v ) {
	vDispSave = v;
}
function setSaveUse( use ) {
	if ( use ) saveItem( "save_use", "on" );
	else saveItem( "save_use", "off" );
}
function getSaveUse() {
	var value;
	value = loadItem( "save_use" );
	if ( value != null ) {
		if ( value == "on" ) return true;
	}
	return false;
}
function getSaveFile() {
	var value;
	value = loadItem( "save_file" );
	if ( value != null ) return value;
	else return null;
}
function getSaveLabel() {
	var value;
	value = loadItem( "save_label" );
	if ( value != null ) return value;
	else return null;
}
function save( label ) {
	// File
	saveItem( "save_file", jamGetReturn() );
	
	// Label
	saveItem( "save_label", label );
	
	// Div
	for ( var i = 0; i < i_save.length; i++ ) {
		saveItem( "s_div_op_" + i_save[i].id, i_save[i].style.opacity );
		if ( 0 < i_save[i].style.opacity ) {
			saveItem( "s_div_iH_" + i_save[i].id, i_save[i].innerHTML );
			
			if ( i_save[i].id.indexOf( "SceneFG" ) != -1 ) { // これはスタイル必須
				saveItem( "s_div_st_" + i_save[i].id, i_save[i].style[jamTransformBP()] );
			}
		}
	}
	for ( var i = 0; i < t_save.length; i++ ) {
		saveItem( "s_div_op_" + t_save[i].id, t_save[i].style.opacity );
		if ( 0 < t_save[i].style.opacity ) {
			saveItem( "s_div_iH_" + t_save[i].id, t_save[i].innerHTML );
		}
	}
	//saveItem( "s_div_op_" + wHis.id, wHis.style.opacity );
	//if ( 0 < wHis.style.opacity ) {
	//	saveItem( "s_div_iH_" + wHis.id, wHis.innerHTML );
	//}
	//for ( var key in wHis ){
	//	console.log( key +" = " + wHis[key] );
	//}
	
	// Audio
	saveItem( "s_audio_" + "play", vNowPlay );
	
	// Score
	saveItem( "s_scr_c", vScoreCount );
	saveItem( "s_scr_t", vScoreTotal );
	saveItem( "s_scr_t1", vScoreT1 );
	saveItem( "s_scr_t2", vScoreT2 );
	saveItem( "s_scr_t3", vScoreT3 );
}
function saveFlag( flag, value ) {
	saveItem( "flag_" + flag, value );
}
function loadFlag( flag ) {
	var value;
	value = loadItem( "flag_" + flag );
	if ( value != null ) return value;
	else return null;
}
function loadDiv() {
	var value;
jamGetRootElem().opacity = 0.0;

	for ( var i = 0; i < i_save.length; i++ ) {
		value = loadItem( "s_div_op_" + i_save[i].id );
		if ( value != null ) i_save[i].style.opacity = value;
		if ( 0 < parseFloat( value ) ) {
			value = loadItem( "s_div_iH_" + i_save[i].id );
			if ( value != null ) i_save[i].innerHTML = value;
			
			if ( i_save[i].id.indexOf( "SceneFG" ) != -1 ) { // これはスタイル必須
				value = loadItem( "s_div_st_" + i_save[i].id );
				if ( value != null ) i_save[i].style[jamTransformBP()] = value;
			}
		}
	}
jamGetRootElem().opacity = 0.25;

	for ( var i = 0; i < t_save.length; i++ ) {
		value = loadItem( "s_div_op_" + t_save[i].id );
		if ( value != null ) t_save[i].style.opacity = value;
		if ( 0 < parseFloat( value ) ) {
			value = loadItem( "s_div_iH_" + t_save[i].id );
			if ( value != null ) t_save[i].innerHTML = value;
		}
	}
jamGetRootElem().opacity = 0.5;

	//value = loadItem( "s_div_op_" + wHis.id );
	//if ( value != null ) wHis.style.opacity = value;
	//if ( 0 < parseInt( value ) ) {
	//	value = loadItem( "s_div_iH_" + wHis.id );
	//	if ( value != null ) wHis.innerHTML = value;
	//}
	//wHis.scrollTop = wHis.scrollHeight;
	wHis.style.opacity = getHistorySO();
	
	tC1b.style.opacity = tC1.style.opacity;
	tC2b.style.opacity = tC2.style.opacity;
	tC3b.style.opacity = tC3.style.opacity;
jamGetRootElem().opacity = 0.75;

	var elems;
	elems = iCF1.getElementsByTagName("img");
	if ( 0 < elems.length) vCF1src = elems[0].src;
	elems = iCF2.getElementsByTagName("img");
	if ( 0 < elems.length) vCF2src = elems[0].src;
	elems = iCF3.getElementsByTagName("img");
	if ( 0 < elems.length) vCF3src = elems[0].src;
	
	iCF1o.innerHTML = iCF1.innerHTML; iCF1o.style.opacity = iCF1.style.opacity; 
	iCF2o.innerHTML = iCF2.innerHTML; iCF2o.style.opacity = iCF2.style.opacity; 
	iCF3o.innerHTML = iCF3.innerHTML; iCF3o.style.opacity = iCF3.style.opacity; 
jamGetRootElem().opacity = 1.0;
}
function loadAudio() {
	var value;
	value = loadItem( "s_audio_" + "play" );
	if ( value != null ) {
		jamPlayAudio( value ); vNowPlay = value;
	}
}
function loadScore() {
	var value;
	value = loadItem( "s_scr_c" ); if ( value != null ) vScoreCount = parseInt( value );
	value = loadItem( "s_scr_t" ); if ( value != null ) vScoreTotal = parseInt( value );
	value = loadItem( "s_scr_t1" ); if ( value != null ) vScoreT1 = parseInt( value );
	value = loadItem( "s_scr_t2" ); if ( value != null ) vScoreT2 = parseInt( value );
	value = loadItem( "s_scr_t3" ); if ( value != null ) vScoreT3 = parseInt( value );
}
function initScore() {
	vScoreCount = 0;
	vScoreTotal = 0;
	vScoreT1 = 0;
	vScoreT2 = 0;
	vScoreT3 = 0;
}

function genScoreText( t1, t2, t3, score, combo, bonus, add ) {
	var t = "";
	if ( vScoreCount < combo ) bonus = 0;
	t = t + "<table style='background-color:rgba(0,0,0,0.8)'><tr><td class='CaptionCenter'>";
	if ( t1 != 0 ) t = t + "観察成功率 ： " + vScoreT1 + "％ + <txbg1>" + t1 + "％</txbg1> ⇒ " + (vScoreT1 + t1) + "％<br>";
	if ( t2 != 0 ) t = t + "分析成功率 ： " + vScoreT2 + "％ + <txbg1>" + t2 + "％</txbg1> ⇒ " + (vScoreT2 + t2) + "％<br>";
	if ( t3 != 0 ) t = t + "推理成功率 ： " + vScoreT3 + "％ + <txbg1>" + t3 + "％</txbg1> ⇒ " + (vScoreT3 + t3) + "％<br>";
	if ( score != 0 ) t = t + "<txhl>獲得スコア <txbg1>" + score + "</txbg1></txhl><br>";
	if ( bonus != 0 ) t = t + "<txhl>連続正解ボーナス <txbg2>" + bonus + "</txbg2></txhl><br>" + "<img src='" + vImageFN + "success.png'><br>";
	if ( (score != 0) || (bonus != 0) ) t = t + "総合スコア ： " + vScoreTotal + " ⇒ " + (vScoreTotal + score + bonus) + "<br>";
	t = t + "</td></tr></table>";
	if ( add ) {
		vScoreT1 += t1; vScoreT2 += t2; vScoreT3 += t3;
		vScoreTotal += score + bonus;
	}
	return t;
}
function genResultText() {
	var t = "";
	t = t + "<table style='background-color:rgba(0,0,0,0.8)'><tr><td class='CaptionCenter'>";
	t = t + "<txbg1>観察成功率 ：<txhl> " + vScoreT1 + "</txhl>％</txbg1><br>";
	t = t + "<txbg1>分析成功率 ：<txhl> " + vScoreT2 + "</txhl>％</txbg1><br>";
	t = t + "<txbg1>推理成功率 ： <txhl>" + vScoreT3 + "</txhl>％</txbg1><br>";
	t = t + "<txbg2>総合スコア ： <txhl>" + vScoreTotal + "</txhl></txbg2>/10000<br>";
	t = t + "</td></tr></table>";
	return t;
}
function genStoryText( text ) {
	if ( text == null ) return null;
	text = text.replace( /《/g, "<txbg1>" );
	text = text.replace( /》/g, "</txbg1>" );
	text = text.replace( /〈/g, "<txhl>" );
	text = text.replace( /〉/g, "</txhl>" );
	text = text.replace( /【/g, "<txnm>" );
	text = text.replace( /】/g, "</txnm>" );
	text = text.replace( /、/g, "<txsm2>、</txsm2>" );
	text = text.replace( /　/g, "<txsm2>　</txsm2>" );
	text = text.replace( /『/g, "<txsm1>『</txsm1>" );
	text = text.replace( /』/g, "<txsm1>』</txsm1>" );
	text = text.replace( /「/g, "<txsm1>「</txsm1>" );
	text = text.replace( /」/g, "<txsm1>」</txsm1>" );
	text = text.replace( /……/g, "<txsm2>……</txsm2>" );
	text = text.replace( /──/g, "<txsm2>──</txsm2>" );
	return text;
}

function emoCF( type, iCF, iCFx ) {
	if ( type == "ang" ) { // anger 5
		return [
			"time", 125, "",
				jacDivTransform( iCF, [1], [0], [0, 0, 0, -5] ),
			"time", 125, "",
				jacDivTransform( iCF, [1], [0], [0, 0, -5, 0] ),
			"time", 125, "",
				jacDivTransform( iCF, [1], [0], [0, 0, 0, -5] ),
			"time", 125, "",
				jacDivTransform( iCF, [1], [0], [0, 0, -5, 0] ),
			"time", 125, "",
				jacDivTransform( iCF, [1], [0], [0, 0, 0, -5] ),
			"time", 125, "",
				jacDivTransform( iCF, [1], [0], [0, 0, -5, 0] ),
			"time", 125, "",
				jacDivTransform( iCF, [1], [0], [0, 0, 0, -5] ),
			"time", 125, "",
				jacDivTransform( iCF, [1], [0], [0, 0, -5, 0] ),
			"time", 125, "",
				jacDivTransform( iCF, [1], [0], [0, 0, 0, -5] ),
			"time", 125, "",
				jacDivTransform( iCF, [1], [0], [0, 0, -5, 0] ),
			"time", 125, "",
				jacDivTransform( iCF, [1], [0], [0, 0, 0, -5] ),
			"time", 125, "",
				jacDivTransform( iCF, [1], [0], [0, 0, -5, 0] ),
		];
	}
	if ( type == "dpl" ) { // displeasure 6
		return [
			"time", 1000, "",
				jacDivTransform( iCF, [1], [0, 5], [0] ),
			"time", 1000, "",
				jacDivTransform( iCF, [1], [5, 0], [0] ),
		];
	}
	if ( type == "sry" ) { // sorry 7
		return [
			"time", 300, "",
				jacDivTransform( iCF, [1], [0, 2.5], [0] ),
			"time", 300, "",
				jacDivTransform( iCF, [1], [2.5, -2.5], [0] ),
			"time", 300, "",
				jacDivTransform( iCF, [1], [-2.5, 2.5], [0] ),
			"time", 300, "",
				jacDivTransform( iCF, [1], [2.5, -2.5], [0] ),
			"time", 300, "",
				jacDivTransform( iCF, [1], [-2.5, 0], [0] ),
		];
	}
	if ( type == "agr" ) { // agree 9
		return [
			"time", 250, "",
				jacDivTransform( iCF, [1], [0, 5], [0] ),
			"time", 250, "",
				jacDivTransform( iCF, [1], [5, 0], [0] ),
			"time", 250, "",
				jacDivTransform( iCF, [1], [0, 5], [0] ),
			"time", 250, "",
				jacDivTransform( iCF, [1], [5, 0], [0] ),
		];
	}
	if ( type == "thk" ) { // think 10
		return [
			"time", 250, "",
				jacDivTransform( iCF, [1], [0, 5], [0] ),
			"time", 1000, "",
				jacDivTransform( iCF, [1], [5, -5], [0] ),
			"time", 500, "",
				jacDivTransform( iCF, [1], [-5, 0], [0] ),
		];
	}
	if ( type == "spr" ) { // surprised 11
		return [
			"time", 125, "",
				jacDivTransform( iCF, [1], [0], [0, 0, 0, -15] ),
			"time", 250, "",
				jacDivTransform( iCF, [1], [0], [0, 0, -15, 0] ),
		];
	}
	if ( type == "lup" ) { // look up 98
		return [
			"time", 1500, "",
				jacDivTransform( iCF, [1], [0, -15], [0] ),
			"time", 500, "",
				jacDivTransform( iCF, [1], [-15, 0], [0] ),
		];
	}
	if ( type == "bow" ) { // bow 99
		return [
			"time", 250, "",
				jacDivTransform( iCF, [1], [0, 5], [0] ),
			"time", 750, "",
				jacDivTransform( iCF, [1], [5, 5], [0] ),
			"time", 500, "",
				jacDivTransform( iCF, [1], [5, 0], [0] ),
		];
	}
	
	if ( type == "qst" ) { // question
		return [
			"time", 250, "",
				jacDivImage( iCFx, vImageFN+"f01qst.png", [0, 1] ),
			"time", 1000, "",
				jacTransform( iCFx, [1], [0, 20], [0] ),
				jacDivTransform( iCF, [1], [0, 10], [0] ),
			"time", 500, "",
				jacTransform( iCFx, [1], [20, 0], [0] ),
				jacDivTransform( iCF, [1], [10, 0], [0] ),
			"time", 250, "",
				jacDivOpacityEx( iCFx, [1, 0] ),
		];
	}
	if ( type == "exc" ) { // exclamation
		return [
			"time", 250, "",
				jacDivImage( iCFx, vImageFN+"f01exc.png", [0, 1] ),
			"time", 250, "",
				jacTransform( iCFx, [1, 1.25], [0], [0, 0, 0, -15] ),
				jacDivTransform( iCF, [1], [0], [0, 0, 0, -15] ),
			"time", 1250, "",
				jacTransform( iCFx, [1.25, 1], [0], [0, 0, -15, 0] ),
				jacDivTransform( iCF, [1], [0], [0, 0, -15, 0] ),
			"time", 250, "",
				jacDivOpacityEx( iCFx, [1, 0] ),
		];
	}
	if ( type == "excqst" ) { // exclamation + question
		return [
			"time", 250, "",
				jacDivImage( iCFx, vImageFN+"f01excqst.png", [0, 1] ),
			"time", 250, "",
				jacTransform( iCFx, [1, 1.25], [0], [0, 0, 0, -15] ),
				jacDivTransform( iCF, [1], [0], [0, 0, 0, -15] ),
			"time", 1000, "",
				jacTransform( iCFx, [1.25, 1.25], [0, 20], [0, 0, -15, -15] ),
				jacDivTransform( iCF, [1], [0, 10], [0, 0, -15, -15] ),
			"time", 250, "",
				jacTransform( iCFx, [1.25, 1], [20, 0], [0, 0, -15, 0] ),
				jacDivTransform( iCF, [1], [10, 0], [0, 0, -15, 0] ),
			"time", 250, "",
				jacDivOpacityEx( iCFx, [1, 0] ),
		];
	}
	if ( type == "excexc" ) { // exclamation + exclamation
		return [
			"time", 250, "",
				jacDivImage( iCFx, vImageFN+"f01excexc.png", [0, 1] ),
			"time", 250, "",
				jacTransform( iCFx, [1, 1.25], [0, 0], [0, 0, 0, -15] ),
				jacDivTransform( iCF, [1], [0, 0], [0, 0, 0, -15] ),
			"time", 250, "",
				jacTransform( iCFx, [1.25, 1.25], [0, 20], [0, 0, -15, -15] ),
				jacDivTransform( iCF, [1], [0, 10], [0, 0, -15, -15] ),
			"time", 250, "",
				jacTransform( iCFx, [1.25, 1.25], [20, -20], [0, 0, -15, -15] ),
				jacDivTransform( iCF, [1], [10, -10], [0, 0, -15, -15] ),
			"time", 250, "",
				jacTransform( iCFx, [1.25, 1.25], [-20, 0], [0, 0, -15, -15] ),
				jacDivTransform( iCF, [1], [-10, 0], [0, 0, -15, -15] ),
			"time", 500, "",
				jacTransform( iCFx, [1.25, 1], [0, 0], [0, 0, -15, 0] ),
				jacDivTransform( iCF, [1], [0, 0], [0, 0, -15, 0] ),
			"time", 250, "",
				jacDivOpacityEx( iCFx, [1, 0] ),
		];
	}
	return ["time", 100, ""];
}
function emoCX( type, tC ) {
	if ( type == "lud" ) { // loud ?
		return [
			"time", 250, "",
				jacTransform( tC, [1, 1.1], [0], [0, 0, 0, -5] ),
			"time", 750, "",
				jacTransform( tC, [1.1, 1], [0], [0, 0, -5, 0] ),
		];
	}
	return ["time", 100, ""];
}
